from collections import deque, defaultdict


def find_guarded_warehouses(n, m, k, roads, guards):
    graph = defaultdict(list)
    for a, b in roads:
        graph[a].append(b)
        graph[b].append(a)

    guarded = set()

    for guard_position, guard_range in guards:
        queue = deque([(guard_position, 0)])
        visited = set()
        visited.add(guard_position)

        while queue:
            current_position, current_distance = queue.popleft()

            if current_distance <= guard_range:
                guarded.add(current_position)

                for neighbor in graph[current_position]:
                    if neighbor not in visited:
                        visited.add(neighbor)
                        queue.append((neighbor, current_distance + 1))

    guarded_list = sorted(guarded)
    return len(guarded_list), guarded_list


n, m, k = map(int, input().split())
roads = [tuple(map(int, input().split())) for _ in range(m)]
guards = [tuple(map(int, input().split())) for _ in range(k)]

count, guarded_warehouses = find_guarded_warehouses(n, m, k, roads, guards)

print(count)
print(" ".join(map(str, guarded_warehouses)))