import itertools
import decimal

decimal.getcontext().prec = 30


def dist(p1, p2):
    dx = decimal.Decimal(p1[0] - p2[0])
    dy = decimal.Decimal(p1[1] - p2[1])
    return (dx ** 2 + dy ** 2).sqrt()


def solve():
    try:
        n = int(input())
        if not 2 <= n <= 12:
            raise ValueError("n должно быть в диапазоне от 2 до 12")
        points = []
        for _ in range(n):
            x, y = map(int, input().split())
            points.append((x, y))

        m_d = float('inf')
        for permutation in itertools.permutations(points):
            t_d = decimal.Decimal(0)
            for i in range(n - 1):
                t_d += dist(permutation[i], permutation[i + 1])
            m_d = min(m_d, float(t_d))

        print(m_d)
    except ValueError as e:
        print(f"Ошибка: {e}")
    except EOFError:
        print("Ошибка: Преждевременный конец файла")
    except Exception as e:
        print(f"Произошла непредвиденная ошибка: {e}")


solve()